require 'spec_helper'

describe Magellan::LogFunnel do
  before do
    @command = [ "/bin/echo", "foo" ]
    @argv = [
      "--fluentd", "http://fluentd.example:8888",
      "--project", "PROJECT1",
      "--stage", "STAGE1",
      "--worker-version", "1.0",
      "--container", "CONTAINER1",
    ] + @command
    @funnel = Magellan::LogFunnel.new(@argv)
    # stub Net::HTTP.post_form
    @now = Time.now
    allow(@funnel).to receive(:now).and_return(@now)
    @test_logger = Fluent::Logger::TestLogger.new
    expect(Fluent::Logger::FluentLogger).to receive(:new).and_return(@test_logger)
  end
  it 'can handle stdout' do
    expect(@funnel.run).to eql(0)
    expect(@test_logger.queue.count).to eql(1)
    expect(@test_logger.queue.last).to eql({
      time: @now.to_f,
      project: "PROJECT1",
      stage: "STAGE1",
      version: "1.0",
      container: "CONTAINER1",
      message: "foo"
    })
  end
end
